﻿using System.ComponentModel;
using System.Text;

namespace TestClient;

/// <summary>
/// 부품
/// </summary>
[Serializable]
public class Part : INotifyPropertyChanged
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Event
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 속성 변경시 - PropertyChanged

    /// <summary>
    /// 속성 변경시
    /// </summary>
    public event PropertyChangedEventHandler PropertyChanged;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// 부품 ID
    /// </summary>
    private string partID;

    /// <summary>
    /// 부품명
    /// </summary>
    private string partName;

    /// <summary>
    /// 부품 타입
    /// </summary>
    private string partType;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 부품 ID - PartID

    /// <summary>
    /// 부품 ID
    /// </summary>
    public string PartID
    {
        get => this.partID;
        set
        {
            if(this.partID == value)
            {
                return;
            }

            this.partID = value;

            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(PartID)));
        }
    }

    #endregion
    #region 부품명 - PartName

    /// <summary>
    /// 부품명
    /// </summary>
    public string PartName
    {
        get => this.partName;
        set
        {
            if(this.partName == value)
            {
                return;
            }

            this.partName = value;

            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(PartName)));
        }
    }

    #endregion
    #region 부품 타입 - PartType

    /// <summary>
    /// 부품 타입
    /// </summary>
    public string PartType
    {
        get => this.partType;
        set
        {
            if(this.partType == value)
            {
                return;
            }

            this.partType = value;

            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(PartType)));
        }
    }

    #endregion
    #region 공급자 리스트 - SupplierList

    /// <summary>
    /// 공급자 리스트
    /// </summary>
    public List<string> SupplierList { get; set; }

    #endregion
    #region 공급자 리스트 2 - SupplierList2

    /// <summary>
    /// 공급자 리스트 2
    /// </summary>
    public string SupplierList2
    {
        get
        {
            StringBuilder stringBuilder = new StringBuilder();

            foreach(string supplier in SupplierList)
            {
                stringBuilder.Append($"{supplier}, ");
            }

            return stringBuilder.ToString().TrimEnd(',');
        }
    }

    #endregion
    #region 부품 이용 가능일 - PartAvailableDate

    /// <summary>
    /// 부품 이용 가능일
    /// </summary>
    public DateTime PartAvailableDate { get; set; }

    #endregion
}