﻿using Microsoft.AspNetCore.Mvc;

using TestServer.Models;

namespace TestServer.Controllers;

/// <summary>
/// 로그인 컨트롤러
/// </summary>
[Route("api/[controller]")]
[ApiController]
public class LoginController : BaseController
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 구하기 - Get()

    /// <summary>
    /// 구하기
    /// </summary>
    /// <returns>액션 결과</returns>
    [HttpGet]
    public ActionResult Get()
    {
        try
        {
            string authorizationToken = Guid.NewGuid().ToString();

            PartFactory.Initialize(authorizationToken);

            return new JsonResult(authorizationToken);
        }
        catch(Exception exception)
        {
            return new JsonResult(exception.Message);
        }
    }

    #endregion
}